## ros-foxy-rclc 1.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclc)

set(CMAKE_VERBOSE_MAKEFILE ON)

#################################################
# compiler settings
#################################################

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(CMAKE_VERBOSE_MAKEFILE ON)

#################################################
# package dependencies
#################################################
find_package(ament_cmake_ros REQUIRED)
find_package(rcl REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_generator_c REQUIRED)

if("${rcl_VERSION}" VERSION_LESS "1.0.0")
  message(STATUS "Found rcl version ${rcl_VERSION}, which belongs to Dashing or Eloquent")
  # Later, with CMake 3.12+ use:
  # add_compile_definitions(USE_RCL_WAIT_SET_IS_VALID_BACKPORT)
  add_definitions(-DUSE_RCL_WAIT_SET_IS_VALID_BACKPORT)
else()
  message(STATUS "Found rcl version ${rcl_VERSION}, which belongs to Foxy or later")
  find_package(rosidl_runtime_c REQUIRED)
endif()

#################################################
# create library
#################################################

add_library(${PROJECT_NAME}
  src/rclc/init.c
  src/rclc/publisher.c
  src/rclc/subscription.c
  src/rclc/client.c
  src/rclc/service.c
  src/rclc/timer.c
  src/rclc/node.c
  src/rclc/executor_handle.c
  src/rclc/executor.c
  src/rclc/sleep.c
)
if("${rcl_VERSION}" VERSION_LESS "1.0.0")
  target_sources(${PROJECT_NAME} PRIVATE src/rclc/rcl_wait_set_is_valid_backport.c)
endif()

target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)

target_link_libraries(${PROJECT_NAME} ${CMAKE_THREAD_LIBS_INIT})
# specific order: dependents before dependencies
ament_target_dependencies(${PROJECT_NAME}
  rcl
  rcutils
  rosidl_generator_c
)

#################################################
# install
#################################################
#install(DIRECTORY include/ DESTINATION include)
#install(TARGETS ${PROJECT_NAME} DESTINATION lib)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "RCLC_BUILDING_LIBRARY")

install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(
  DIRECTORY include/
  DESTINATION include
)

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

if("${rcl_VERSION}" VERSION_LESS "1.1.10")
# ament_export_targets command is not available for Dashing
else()
ament_export_targets(${PROJECT_NAME})
endif()


#################################################
# gtest
#################################################
if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  set(ament_cmake_copyright_FOUND TRUE) # No copyright header check since link to NOTICE file is not recognized properly.
  find_package(osrf_testing_tools_cpp REQUIRED)
  find_package(std_msgs REQUIRED)
  find_package(example_interfaces REQUIRED)

  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(${PROJECT_NAME}_test
    test/rclc/test_init.cpp
    test/rclc/test_node.cpp
    test/rclc/test_publisher.cpp
    test/rclc/test_subscription.cpp
    test/rclc/test_client.cpp
    test/rclc/test_service.cpp
    test/rclc/test_timer.cpp
    test/rclc/test_executor_handle.cpp
    test/rclc/test_executor.cpp
  )

  target_include_directories(${PROJECT_NAME}_test PRIVATE include src)
  target_link_libraries(${PROJECT_NAME}_test ${PROJECT_NAME})
  ament_target_dependencies(${PROJECT_NAME}_test
    rcl
    rcutils
    rosidl_generator_c
    osrf_testing_tools_cpp
    std_msgs
    test_msgs
    example_interfaces
  )


endif()

#################################################
# export dependencies
#################################################
# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl)
ament_export_dependencies(rcutils)
ament_export_dependencies(rosidl_generator_c)
ament_package()

=== debian/changelog ===
ros-foxy-rclc (1.1.2-1focal) focal; urgency=high

  * Added build status of bloom-releases for Humble distribution (backport #291) (#294)
  * [rolling] updated ros-tooling versions (backport #289) (#299)
  * added documentation (#301) (#304)
  * Drop build dependency on std_msgs (backport #314) (#317)
  * Updated ros-tooling versions (backport #318) (#319)
  * removed build status for Galactic distribution in README (backport #321) (#323)
  * Update documentation about number_of_handles (#326) (#328)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Thu, 30 Mar 2023 22:00:00 -0000

ros-foxy-rclc (1.1.1-1focal) focal; urgency=high

  * Fix enum naming for avoid collision (backport #242) (#243)
  * Backport parameters (#263)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 15 Mar 2022 23:00:00 -0000

ros-foxy-rclc (1.1.0-1focal) focal; urgency=high

  * Update codecov to ignore rclc_examples and all test folders (backport #145) (#150)
  * Updated table of bloom releases (removed dashing, inserted galactic) (backport #147) (#152)
  * Refactor #116 remove callback_type (#154)
  * Fix codecov to ignore unit tests and rclc_examples package (backport #155) (#162)
  * Feature request: check for valid ros context in spin_some (#165) (#167)
  * Ignoring unsuccessful SERVICE_TAKE (#175) (#177)
  * Backport windows port of PR #144 (#182)
  * Fix: printf in executor spin (#195) (#197)
  * Fix init options handling (#202) (#204)
  * [backport galactic, foxy] data_available optimization (backport #212) (#213)
  * Fix data_available reset for timer (#215)
  * Executor ignore canceled timers (#220) (#222)
  * Resolved error in unit test see issue #230 (#231) (#233)
  * Updated documentation README.md (#234)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Mon, 24 Jan 2022 23:00:00 -0000

ros-foxy-rclc (1.0.2-1focal) focal; urgency=high

  * Bumped version (tag with version 1.0.1 already exists)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Fri, 16 Jul 2021 22:00:00 -0000

ros-foxy-rclc (1.0.1-1focal) focal; urgency=high

  * Added quality of service entity creation API
  * Added executor prepare API
  * Added support to add subscription with context to executor
  * Added support for removing subscription from executor
  * Updated compatability function for sleep
  * Added quality declaration statement
  * Used executor allocator in spin

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Fri, 16 Jul 2021 22:00:00 -0000

ros-foxy-rclc (1.0.0-1focal) focal; urgency=high

  * Service callbacks with context
  * Fixed minor issues unit tests
  * Upgraded setup_ros action (ci jobs)
  * Removed Eloquent from ci jobs

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 03 Mar 2021 23:00:00 -0000

ros-foxy-rclc (0.1.7-1focal) focal; urgency=high

  * Corrected corrupted changelog

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 19 Jan 2021 23:00:00 -0000

ros-foxy-rclc (0.1.6-1focal) focal; urgency=high

  * Fixed issues due to Github Action timing delays on cloud build
  * Fixed missing package dependency in Github Action for Eloquent

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 19 Jan 2021 23:00:00 -0000

ros-foxy-rclc (0.1.5-1focal) focal; urgency=high

  * Added support for services,clients and guard_conditions to rclc executor
  * Added table for bloom release status in README file

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Thu, 10 Dec 2020 23:00:00 -0000

ros-foxy-rclc (0.1.4-1focal) focal; urgency=high

  * Fixed error in bloom release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 24 Nov 2020 23:00:00 -0000

ros-foxy-rclc (0.1.3-1focal) focal; urgency=high

  * Added rclc_lifecycle package
  * Change maintainer information
  * Minor fixes, updated unit tests

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 22 Nov 2020 23:00:00 -0000

ros-foxy-rclc (0.1.2-1focal) focal; urgency=high

  * Fixed compiler errors for bloom release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Mon, 18 May 2020 22:00:00 -0000

ros-foxy-rclc (0.1.1-1focal) focal; urgency=high

  * Initial release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 13 May 2020 22:00:00 -0000

=== debian/control ===
Source: ros-foxy-rclc
Section: misc
Priority: optional
Maintainer: Jan Staschulat <jan.staschulat@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-cmake-pytest <!nocheck>, ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-example-interfaces <!nocheck>, ros-foxy-launch-testing <!nocheck>, ros-foxy-osrf-testing-tools-cpp <!nocheck>, ros-foxy-rcl, ros-foxy-rcutils, ros-foxy-rosidl-generator-c, ros-foxy-rosidl-typesupport-c, ros-foxy-std-msgs <!nocheck>, ros-foxy-test-msgs <!nocheck>, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rclc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-rcl, ros-foxy-rcutils, ros-foxy-rosidl-generator-c, ros-foxy-ros-workspace
Description: The ROS client library in C.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rclc//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
